;  Program Written in HAL85
#include ti-85.h
#define TI85-ZSHELL
MAX_X = 127
MAX_Y = 63
MAX_COL = 20
MAX_ROW = 7
  .org 0
  .db "Move!  ver 0.8   ..jR",0
  SET 0,(IY+03)
; CODE
;Move ver.02
;** Menu Display Screen
beginning:
; line 5 :  byte a
var_a  =  GRAPH_MEM + 0
; line 6 :  byte b
var_b  =  GRAPH_MEM + 1
; line 7 :  byte c
var_c  =  GRAPH_MEM + 2
; line 8 :  byte xcount
var_xcount  =  GRAPH_MEM + 3
; line 9 :  byte ycount
var_ycount  =  GRAPH_MEM + 4
; line 10 :  cls
  ROM_CALL(CLEARLCD)
; line 11 :  reverse
  SET 3,(IY+05)
; line 12 :  disp text 4 0 "             "
  LD A,4
  LD D,A
  LD A,0
  LD H,D
  LD L,A
  LD (CURSOR_ROW),HL
  LD HL,STR0
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZT_STR)
; line 13 :  disp text 4 1 "             "
  LD A,4
  LD D,A
  LD A,1
  LD H,D
  LD L,A
  LD (CURSOR_ROW),HL
  LD HL,STR1
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZT_STR)
; line 14 :  disp menu 55 5 "MOVE!"
  LD A,55
  LD D,A
  LD A,5
  LD L,D
  LD H,A
  LD (CURSOR_X),HL
  LD HL,STR2
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZM_STR)
; line 15 :  normal
  RES 3,(IY+05)
; line 16 :  disp menu 110 8 "...JR"
  LD A,110
  LD D,A
  LD A,8
  LD L,D
  LD H,A
  LD (CURSOR_X),HL
  LD HL,STR3
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZM_STR)
; line 17 :  disp menu 35 30 "F1 - START GAME"
  LD A,35
  LD D,A
  LD A,30
  LD L,D
  LD H,A
  LD (CURSOR_X),HL
  LD HL,STR4
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZM_STR)
;**  Menu Getkey **
Menu:
; line 21 :  a = (waitkey)
sys_loop0:
  HALT
  CALL GET_KEY
  OR A
  jr z,sys_loop0
  LD L,A
  ld A,L
  LD (var_a),A
; line 22 :    if (a == K_EXIT)
  LD A,(var_a)
  LD D,A
  LD A,K_EXIT
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_1)
      RET
; line 24 :    endif
if_not_true_1:
; line 25 :    if (a == K_F1)
  LD A,(var_a)
  LD D,A
  LD A,K_F1
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_2)
; line 26 :      goto Declare
  JUMP_(Declare)
; line 27 :    endif
if_not_true_2:
; line 28 :  goto menu
  JUMP_(menu)
;**  Declare Variables **
Declare:
; line 31 :  byte pxcoor
var_pxcoor  =  GRAPH_MEM + 5
; line 32 :  byte pycoor
var_pycoor  =  GRAPH_MEM + 6
; line 33 :  byte psxcoor
var_psxcoor  =  GRAPH_MEM + 7
; line 34 :  byte psycoor
var_psycoor  =  GRAPH_MEM + 8
; line 35 :  byte npx
var_npx  =  GRAPH_MEM + 9
; line 36 :  byte npy
var_npy  =  GRAPH_MEM + 10
; line 37 :  byte npsx
var_npsx  =  GRAPH_MEM + 11
; line 38 :  byte npsy
var_npsy  =  GRAPH_MEM + 12
; line 39 :  byte cxcoor
var_cxcoor  =  GRAPH_MEM + 13
; line 40 :  byte cycoor
var_cycoor  =  GRAPH_MEM + 14
; line 41 :  byte csxcoor
var_csxcoor  =  GRAPH_MEM + 15
; line 42 :  byte csycoor
var_csycoor  =  GRAPH_MEM + 16
; line 43 :  byte ncx
var_ncx  =  GRAPH_MEM + 17
; line 44 :  byte ncy
var_ncy  =  GRAPH_MEM + 18
; line 45 :  byte ncsx
var_ncsx  =  GRAPH_MEM + 19
; line 46 :  byte ncsy
var_ncsy  =  GRAPH_MEM + 20
; line 47 :  byte lives
var_lives  =  GRAPH_MEM + 21
; line 48 :  byte level
var_level  =  GRAPH_MEM + 22
; line 49 :  byte nx
var_nx  =  GRAPH_MEM + 23
; line 50 :  byte ny
var_ny  =  GRAPH_MEM + 24
; line 51 :  byte maincount
var_maincount  =  GRAPH_MEM + 25
; line 52 :  byte subcount
var_subcount  =  GRAPH_MEM + 26
; line 53 :  perm_byte number
var_number  =  GRAPH_MEM + 27
  LD HL,Perm_number
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  LD (var_number),HL
; line 54 :  byte subx
var_subx  =  GRAPH_MEM + 29
; line 55 :  byte suby
var_suby  =  GRAPH_MEM + 30
; line 56 :  byte keypress
var_keypress  =  GRAPH_MEM + 31
; line 57 :  byte nonum
var_nonum  =  GRAPH_MEM + 32
; line 58 :  byte mxcoor
var_mxcoor  =  GRAPH_MEM + 33
; line 59 :  byte mycoor
var_mycoor  =  GRAPH_MEM + 34
; line 60 :  bmatrix lvl 19 11
var_lvl  =  GRAPH_MEM + 35
; line 61 :  lives = 4
  LD A,4
  LD (var_lives),A
; line 62 :  level = 1
  LD A,1
  LD (var_level),A
;** Initialize Variables **
Init:
; line 66 :  cls
  ROM_CALL(CLEARLCD)
; line 67 :  pxcoor = 2
  LD A,2
  LD (var_pxcoor),A
; line 68 :  pycoor = 2
  LD A,2
  LD (var_pycoor),A
; line 69 :  psxcoor = 2
  LD A,2
  LD (var_psxcoor),A
; line 70 :  psycoor = 2
  LD A,2
  LD (var_psycoor),A
; line 71 :  cxcoor = 18
  LD A,18
  LD (var_cxcoor),A
; line 72 :  cycoor = 10
  LD A,10
  LD (var_cycoor),A
; line 73 :  csxcoor = 18
  LD A,18
  LD (var_csxcoor),A
; line 74 :  csycoor = 10
  LD A,10
  LD (var_csycoor),A
; line 75 :  number = 0
  LD A,0
  LD H,0
  LD L,A
  LD E,H
  LD D,L
  LD HL,var_number
  CALL LD_HL_MHL
  LD (HL),D
  INC HL
  LD (HL),E
; line 76 :  nonum = 2
  LD A,2
  LD (var_nonum),A
; line 77 :  maincount = 0
  LD A,0
  LD (var_maincount),A
; line 78 :  subcount = 0
  LD A,0
  LD (var_subcount),A
;** Create Level **
; line 80 :  if (level > 0)
  LD A,(var_level)
  LD D,A
  LD A,0
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_3)
; line 81 :    for a = 1 to 19
  LD A,1
  LD (var_a),A
forloop_1:
; line 82 :      for b = 1 to 11
  LD A,1
  LD (var_b),A
forloop_2:
; line 83 :        lvl{a,b} = 1
  LD A,1
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_b)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_a)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 84 :      next
  LD A,(var_b)
  INC A
  LD (var_b),A
  DEC A
  LD D,A
  LD A,11
  CP D
  JUMP_NZ(forloop_2)
; line 85 :    next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,19
  CP D
  JUMP_NZ(forloop_1)
; line 86 :     for a = 1 to 19
  LD A,1
  LD (var_a),A
forloop_3:
; line 87 :       lvl{a,1} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,1
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_a)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 88 :       lvl{a,11} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,11
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_a)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 89 :     next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,19
  CP D
  JUMP_NZ(forloop_3)
; line 90 :     for b = 1 to 11
  LD A,1
  LD (var_b),A
forloop_4:
; line 91 :       lvl{1,b} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_b)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,1
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 92 :       lvl{19,b} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_b)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,19
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 93 :     next
  LD A,(var_b)
  INC A
  LD (var_b),A
  DEC A
  LD D,A
  LD A,11
  CP D
  JUMP_NZ(forloop_4)
; line 94 :   endif
if_not_true_3:
; line 95 :   if (level == 2)
  LD A,(var_level)
  LD D,A
  LD A,2
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_4)
; line 96 :     for a = 3 to 9
  LD A,3
  LD (var_a),A
forloop_5:
; line 97 :       lvl{10,a} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_a)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,10
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 98 :     next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,9
  CP D
  JUMP_NZ(forloop_5)
; line 99 :   endif
if_not_true_4:
; line 100 :   if (level == 3)
  LD A,(var_level)
  LD D,A
  LD A,3
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_5)
; line 101 :     for b = 3 to 17
  LD A,3
  LD (var_b),A
forloop_6:
; line 102 :       lvl{b,6} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_b)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 103 :     next
  LD A,(var_b)
  INC A
  LD (var_b),A
  DEC A
  LD D,A
  LD A,17
  CP D
  JUMP_NZ(forloop_6)
; line 104 :   endif
if_not_true_5:
; line 105 :   if (level == 4)
  LD A,(var_level)
  LD D,A
  LD A,4
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_6)
; line 106 :     for a = 3 to 9
  LD A,3
  LD (var_a),A
forloop_7:
; line 107 :       lvl{7,a} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_a)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,7
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 108 :       lvl{13,a} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_a)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,13
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 109 :     next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,9
  CP D
  JUMP_NZ(forloop_7)
; line 110 :     lvl{7,2} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,2
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,7
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 111 :     lvl{13,10} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,10
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,13
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 112 :   endif
if_not_true_6:
; line 113 :   if (level == 5)
  LD A,(var_level)
  LD D,A
  LD A,5
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_7)
; line 114 :     for a = 3 to 9
  LD A,3
  LD (var_a),A
forloop_8:
; line 115 :       lvl{7,a} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_a)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,7
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 116 :       lvl{13,a} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_a)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,13
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 117 :     next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,9
  CP D
  JUMP_NZ(forloop_8)
; line 118 :     for b = 2 to 6
  LD A,2
  LD (var_b),A
forloop_9:
; line 119 :       lvl{b,6} = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_b)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 120 :       c = (b + 12)
  LD A,(var_b)
  LD D,A
  LD A,12
  ADD A,D
  LD L,A
  ld A,L
  LD (var_c),A
; line 121 :       lvl{c,6) = 0
  LD A,0
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_c)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 122 :     next b
  LD A,(var_b)
  INC A
  LD (var_b),A
  DEC A
  LD D,A
  LD A,6
  CP D
  JUMP_NZ(forloop_9)
; line 123 :   endif
if_not_true_7:
;** Display Level **
; line 125 :  for a = 1 to 19
  LD A,1
  LD (var_a),A
forloop_10:
; line 126 :    for b = 1 to 11
  LD A,1
  LD (var_b),A
forloop_11:
; line 127 :      mxcoor = (a * 6)
  LD A,(var_a)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 128 :      mycoor = (b * 6)
  LD A,(var_b)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 129 :      subx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_subx),A
; line 130 :      suby = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_suby),A
; line 131 :        if (lvl{a,b} == 0)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_b)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_a)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_8)
; line 132 :          sprite subx suby WallSprite
  LD A,(var_subx)
  LD B,A
  LD A,(var_suby)
  LD C,A
  LD HL,WallSprite
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 133 :        endif
if_not_true_8:
; line 134 :    next
  LD A,(var_b)
  INC A
  LD (var_b),A
  DEC A
  LD D,A
  LD A,11
  CP D
  JUMP_NZ(forloop_11)
; line 135 :  next
  LD A,(var_a)
  INC A
  LD (var_a),A
  DEC A
  LD D,A
  LD A,19
  CP D
  JUMP_NZ(forloop_10)
;**  Moving Charactor Display Loop **
MoveLoop:
; line 139 :  if (nonum == 1)
  LD A,(var_nonum)
  LD D,A
  LD A,1
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_9)
; line 140 :    mxcoor = (nx * 6)
  LD A,(var_nx)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 141 :    mycoor = (ny * 6)
  LD A,(var_ny)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 142 :    a = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_a),A
; line 143 :    b = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_b),A
; line 144 :    sprite a b Number
  LD A,(var_a)
  LD B,A
  LD A,(var_b)
  LD C,A
  LD HL,Number
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 145 :  endif
if_not_true_9:
; line 146 :  mxcoor = (psxcoor * 6)
  LD A,(var_psxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 147 :  mycoor = (psycoor * 6)
  LD A,(var_psycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 148 :  npsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npsx),A
; line 149 :  npsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npsy),A
; line 150 :  sprite npsx npsy BlankSpace
  LD A,(var_npsx)
  LD B,A
  LD A,(var_npsy)
  LD C,A
  LD HL,BlankSpace
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 151 :  mxcoor = (csxcoor * 6)
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 152 :  mycoor = (csycoor * 6)
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 153 :  ncsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsx),A
; line 154 :  ncsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsy),A
; line 155 :  sprite ncsx ncsy BlankSpace
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,BlankSpace
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 156 :  mxcoor = (pxcoor * 6)
  LD A,(var_pxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 157 :  mycoor = (pycoor * 6)
  LD A,(var_pycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 158 :  npx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npx),A
; line 159 :  npy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npy),A
; line 160 :  sprite npx npy Player
  LD A,(var_npx)
  LD B,A
  LD A,(var_npy)
  LD C,A
  LD HL,Player
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 161 :  mxcoor = (cxcoor * 6)
  LD A,(var_cxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 162 :  mycoor = (cycoor * 6)
  LD A,(var_cycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 163 :  ncx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncx),A
; line 164 :  ncy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncy),A
; line 165 :  sprite ncx ncy Computer
  LD A,(var_ncx)
  LD B,A
  LD A,(var_ncy)
  LD C,A
  LD HL,Computer
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 166 :    if (lvl{csxcoor,csycoor} == 0)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_10)
; line 167 :      mxcoor = (csxcoor * 6)
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 168 :      mycoor = (csycoor * 6)
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 169 :      ncsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsx),A
; line 170 :      ncsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsy),A
; line 171 :      sprite ncsx ncsy WallSprite
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,WallSprite
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 172 :    endif
if_not_true_10:
; line 173 :   psxcoor = pxcoor
  LD A,(var_pxcoor)
  LD (var_psxcoor),A
; line 174 :   psycoor = pycoor
  LD A,(var_pycoor)
  LD (var_psycoor),A
; line 175 :   inc maincount
  LD A,(var_maincount)
  INC A
  LD (var_maincount),A
; line 176 :   inc subcount
  LD A,(var_subcount)
  INC A
  LD (var_subcount),A
;**  Get key from user loop **
KeyLoop:
; line 179 :    keypress = (readkey)
  CALL GET_KEY
  LD L,A
  ld A,L
  LD (var_keypress),A
; line 180 :    if (keypress == K_EXIT)
  LD A,(var_keypress)
  LD D,A
  LD A,K_EXIT
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_11)
      RET
; line 182 :    endif
if_not_true_11:
; line 183 :    if (keypress == K_UP)
  LD A,(var_keypress)
  LD D,A
  LD A,K_UP
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_12)
; line 184 :      dec pycoor
  LD A,(var_pycoor)
  DEC A
  LD (var_pycoor),A
; line 185 :    goto CheckCoor
  JUMP_(CheckCoor)
; line 186 :    endif
if_not_true_12:
; line 187 :    if (keypress == K_DOWN)
  LD A,(var_keypress)
  LD D,A
  LD A,K_DOWN
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_13)
; line 188 :      inc pycoor
  LD A,(var_pycoor)
  INC A
  LD (var_pycoor),A
; line 189 :    goto CheckCoor
  JUMP_(CheckCoor)
; line 190 :    endif
if_not_true_13:
; line 191 :    if (keypress == K_LEFT)
  LD A,(var_keypress)
  LD D,A
  LD A,K_LEFT
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_14)
; line 192 :      dec pxcoor
  LD A,(var_pxcoor)
  DEC A
  LD (var_pxcoor),A
; line 193 :    goto CheckCoor
  JUMP_(CheckCoor)
; line 194 :    endif
if_not_true_14:
; line 195 :    if (keypress == K_RIGHT)
  LD A,(var_keypress)
  LD D,A
  LD A,K_RIGHT
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_15)
; line 196 :      inc pxcoor
  LD A,(var_pxcoor)
  INC A
  LD (var_pxcoor),A
; line 197 :     goto CheckCoor
  JUMP_(CheckCoor)
; line 198 :    endif
if_not_true_15:
; line 199 :    inc xcount
  LD A,(var_xcount)
  INC A
  LD (var_xcount),A
; line 200 :    if (xcount > 10)
  LD A,(var_xcount)
  LD D,A
  LD A,10
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_16)
; line 201 :      inc ycount
  LD A,(var_ycount)
  INC A
  LD (var_ycount),A
; line 202 :    endif
if_not_true_16:
; line 203 :    if (ycount > 9)
  LD A,(var_ycount)
  LD D,A
  LD A,9
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_17)
; line 204 :      ycount = 1
  LD A,1
  LD (var_ycount),A
; line 205 :    endif
if_not_true_17:
; line 206 :    if (xcount > 17)
  LD A,(var_xcount)
  LD D,A
  LD A,17
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_18)
; line 207 :      xcount = 1
  LD A,1
  LD (var_xcount),A
; line 208 :    endif
if_not_true_18:
; line 209 :  goto KeyLoop
  JUMP_(KeyLoop)
;** Check if Coordinates are good **
CheckCoor:
; line 212 :  if (nonum == 2)
  LD A,(var_nonum)
  LD D,A
  LD A,2
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_19)
; line 213 :    nx = (xcount + 1)
  LD A,(var_xcount)
  LD D,A
  LD A,1
  ADD A,D
  LD L,A
  ld A,L
  LD (var_nx),A
; line 214 :    ny = (ycount + 1)
  LD A,(var_ycount)
  LD D,A
  LD A,1
  ADD A,D
  LD L,A
  ld A,L
  LD (var_ny),A
; line 215 :      if lvl{nx,ny} == 1)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_ny)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_nx)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  CP 0
  JUMP_Z(if_not_true_20)
; line 216 :        nonum = 1
  LD A,1
  LD (var_nonum),A
; line 217 :        lvl{nx,ny} = 2
  LD A,2
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_ny)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_nx)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 218 :      endif
if_not_true_20:
; line 219 :  endif
if_not_true_19:
; line 220 :    if (pxcoor == cxcoor)
  LD A,(var_pxcoor)
  LD D,A
  LD A,(var_cxcoor)
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_21)
; line 221 :      if (pycoor == cycoor)
  LD A,(var_pycoor)
  LD D,A
  LD A,(var_cycoor)
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_22)
; line 222 :          goto Captured
  JUMP_(Captured)
; line 223 :       endif
if_not_true_22:
; line 224 :    endif
if_not_true_21:
; line 225 :  if (lvl{pxcoor,pycoor} == 0)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_pycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_pxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_23)
; line 226 :      pxcoor = psxcoor
  LD A,(var_psxcoor)
  LD (var_pxcoor),A
; line 227 :      pycoor = psycoor
  LD A,(var_psycoor)
  LD (var_pycoor),A
; line 228 :    endif
if_not_true_23:
; line 229 :  if (lvl{pxcoor,pycoor} == 2)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_pycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_pxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,2
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_24)
; line 230 :      inc number
  LD HL,(var_number)
  CALL LD_HL_MHL
  INC HL
  LD E,H
  LD D,L
  LD HL,var_number
  CALL LD_HL_MHL
  LD (HL),D
  INC HL
  LD (HL),E
; line 231 :      lvl{pxcoor,pycoor} = 1)
  LD A,1)
  PUSH AF
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_pycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_pxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  LD DE,var_lvl
  ADD HL,DE
  POP AF
  LD (HL),A
; line 232 :      nonum = 2
  LD A,2
  LD (var_nonum),A
; line 233 :      subcount = 0
  LD A,0
  LD (var_subcount),A
; line 234 :      maincount = 0
  LD A,0
  LD (var_maincount),A
; line 235 :  endif
if_not_true_24:
; line 236 :  if (number > 10)
  LD HL,(var_number)
  CALL LD_HL_MHL
  LD D,H
  LD E,L
  LD A,10
  LD H,0
  LD L,A
  CALL_(sys_test_greatw)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_25)
; line 237 :    inc level
  LD A,(var_level)
  INC A
  LD (var_level),A
; line 238 :    goto init
  JUMP_(init)
; line 239 :  endif
if_not_true_25:
; line 240 :  if (maincount == 2)
  LD A,(var_maincount)
  LD D,A
  LD A,2
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_26)
; line 241 :    goto CompMove
  JUMP_(CompMove)
; line 242 :  endif
if_not_true_26:
; line 243 :  goto MoveLoop
  JUMP_(MoveLoop)
;** Time for Computer to Move **
CompMove:
; line 246 :  csxcoor = cxcoor
  LD A,(var_cxcoor)
  LD (var_csxcoor),A
; line 247 :  csycoor = cycoor
  LD A,(var_cycoor)
  LD (var_csycoor),A
; line 248 :  maincount = 0
  LD A,0
  LD (var_maincount),A
; line 249 :  subx = (cxcoor - pxcoor)
  LD A,(var_cxcoor)
  LD E,A
  LD A,(var_pxcoor)
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_subx),A
; line 250 :  suby = (cycoor - pycoor)
  LD A,(var_cycoor)
  LD E,A
  LD A,(var_pycoor)
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_suby),A
; line 251 :    if (subx < 150)
  LD A,(var_subx)
  LD D,A
  LD A,150
  CALL_(sys_test_lessb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_27)
; line 252 :      if (subx == 0)
  LD A,(var_subx)
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_28)
; line 253 :        goto temploop1
  JUMP_(temploop1)
; line 254 :      endif
if_not_true_28:
; line 255 :        dec cxcoor
  LD A,(var_cxcoor)
  DEC A
  LD (var_cxcoor),A
; line 256 :    endif
if_not_true_27:
temploop1:
; line 258 :    if (subx > 150)
  LD A,(var_subx)
  LD D,A
  LD A,150
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_29)
; line 259 :      if (subx == 0)
  LD A,(var_subx)
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_30)
; line 260 :        goto temploop2
  JUMP_(temploop2)
; line 261 :      endif
if_not_true_30:
; line 262 :        inc cxcoor
  LD A,(var_cxcoor)
  INC A
  LD (var_cxcoor),A
; line 263 :    endif
if_not_true_29:
temploop2:
; line 265 :    if (suby < 150)
  LD A,(var_suby)
  LD D,A
  LD A,150
  CALL_(sys_test_lessb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_31)
; line 266 :      if (suby == 0)
  LD A,(var_suby)
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_32)
; line 267 :        goto temploop3
  JUMP_(temploop3)
; line 268 :      endif
if_not_true_32:
; line 269 :        dec cycoor
  LD A,(var_cycoor)
  DEC A
  LD (var_cycoor),A
; line 270 :    endif
if_not_true_31:
temploop3:
; line 272 :    if (suby > 150)
  LD A,(var_suby)
  LD D,A
  LD A,150
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_33)
; line 273 :      if (suby == 0)
  LD A,(var_suby)
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_34)
; line 274 :        goto temploop4
  JUMP_(temploop4)
; line 275 :      endif
if_not_true_34:
; line 276 :        inc cycoor
  LD A,(var_cycoor)
  INC A
  LD (var_cycoor),A
; line 277 :    endif
if_not_true_33:
temploop4:
; line 279 :  if (cxcoor == pxcoor)
  LD A,(var_cxcoor)
  LD D,A
  LD A,(var_pxcoor)
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_35)
; line 280 :      if (cycoor == pycoor)
  LD A,(var_cycoor)
  LD D,A
  LD A,(var_pycoor)
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_36)
; line 281 :        goto Captured
  JUMP_(Captured)
; line 282 :      endif
if_not_true_36:
; line 283 :  endif
if_not_true_35:
;** If it's your 4th move, computer moves again **
; line 285 :    if (subcount == 8)
  LD A,(var_subcount)
  LD D,A
  LD A,8
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_37)
; line 286 :      subcount = 0
  LD A,0
  LD (var_subcount),A
; line 287 :      mxcoor = (csxcoor * 6)
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 288 :      mycoor = (csycoor * 6)
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 289 :      ncsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsx),A
; line 290 :      ncsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsy),A
; line 291 :      sprite ncsx ncsy BlankSpace
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,BlankSpace
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 292 :        if (lvl{csxcoor,csycoor} == 0)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_38)
; line 293 :          sprite ncsx ncsy WallSprite
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,WallSprite
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 294 :        endif
if_not_true_38:
; line 295 :      goto CompMove
  JUMP_(CompMove)
; line 296 :    endif
if_not_true_37:
; line 297 :  goto MoveLoop
  JUMP_(MoveLoop)
;** Getting caught by Computer display **
Captured:
; line 300 :  mxcoor = (psxcoor * 6)
  LD A,(var_psxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 301 :  mycoor = (psycoor * 6)
  LD A,(var_psycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 302 :  npsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npsx),A
; line 303 :  npsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_npsy),A
; line 304 :  sprite npsx npsy BlankSpace
  LD A,(var_npsx)
  LD B,A
  LD A,(var_npsy)
  LD C,A
  LD HL,BlankSpace
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 305 :  mxcoor = (csxcoor * 6)
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 306 :  mycoor = (csycoor * 6)
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 307 :  ncsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsx),A
; line 308 :  ncsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsy),A
; line 309 :  sprite ncsx ncsy BlankSpace
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,BlankSpace
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 310 :  mxcoor = (cxcoor * 6)
  LD A,(var_cxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 311 :  mycoor = (cycoor * 6)
  LD A,(var_cycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 312 :  ncx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncx),A
; line 313 :  ncy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncy),A
; line 314 :  sprite ncx ncy GotYou
  LD A,(var_ncx)
  LD B,A
  LD A,(var_ncy)
  LD C,A
  LD HL,GotYou
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 315 :  if (lvl{csxcoor,csycoor} == 0)
  PUSH HL
  PUSH DE
  LD DE,var_lvl
  PUSH DE
  LD A,19
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  EX DE,HL
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  ADD HL,DE
  POP DE
  ADD HL,DE
  LD A,(HL)
  POP DE
  POP HL
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_39)
; line 316 :    mxcoor = (csxcoor * 6)
  LD A,(var_csxcoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mxcoor),A
; line 317 :    mycoor = (csycoor * 6)
  LD A,(var_csycoor)
  LD H,0
  LD L,A
  LD D,H
  LD E,L
  LD A,6
  LD H,0
  LD L,A
  CALL_(sys_mulemw)
  ld A,L
  LD (var_mycoor),A
; line 318 :    ncsx = (mxcoor - 6)
  LD A,(var_mxcoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsx),A
; line 319 :    ncsy = (mycoor - 6)
  LD A,(var_mycoor)
  LD E,A
  LD A,6
  LD D,A
  LD A,E
  OR A
  SBC A,D
  LD H,0
  LD L,A
  ld A,L
  LD (var_ncsy),A
; line 320 :    sprite ncsx ncsy WallSprite
  LD A,(var_ncsx)
  LD B,A
  LD A,(var_ncsy)
  LD C,A
  LD HL,WallSprite
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  CALL_(sys_PUTSPRITE)
; line 321 :  endif
if_not_true_39:
; line 322 :  if (cycoor < 6)
  LD A,(var_cycoor)
  LD D,A
  LD A,6
  CALL_(sys_test_lessb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_40)
; line 323 :    disp menu 35 45 "I GOT YOU"
  LD A,35
  LD D,A
  LD A,45
  LD L,D
  LD H,A
  LD (CURSOR_X),HL
  LD HL,STR5
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZM_STR)
; line 324 :  endif
if_not_true_40:
; line 325 :  if (cycoor > 6)
  LD A,(var_cycoor)
  LD D,A
  LD A,6
  CALL_(sys_test_greatb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_41)
; line 326 :    disp menu 35 10 "I GOT YOU"
  LD A,35
  LD D,A
  LD A,10
  LD L,D
  LD H,A
  LD (CURSOR_X),HL
  LD HL,STR6
  PUSH DE
  LD DE,(PROGRAM_ADDR)
  ADD HL,DE
  POP DE
  ROM_CALL(D_ZM_STR)
; line 327 :  endif
if_not_true_41:
; line 328 :  dec lives
  LD A,(var_lives)
  DEC A
  LD (var_lives),A
; line 329 :  if (lives == 0)
  LD A,(var_lives)
  LD D,A
  LD A,0
  CALL_(sys_test_equalb)
  ld A,L
  CP 0
  JUMP_Z(if_not_true_42)
    RET
; line 331 :  endif
if_not_true_42:
; line 332 :    a = (waitkey)
sys_loop12:
  HALT
  CALL GET_KEY
  OR A
  jr z,sys_loop12
  LD L,A
  ld A,L
  LD (var_a),A
; line 333 :    goto Init
  JUMP_(Init)
    RET
;** Sprites !!! **
Player:
.db 6,6
.db %00000000
.db %01110000
.db %00100000
.db %11111000
.db %01010000
.db %10001000
Computer:
.db 6,6
.db %00000000
.db %01110000
.db %11111000
.db %00100000
.db %11111000
.db %01110000
GotYou:
.db 6,6
.db %00000000
.db %11111000
.db %11111000
.db %11111000
.db %11111000
.db %11111000
BlankSpace:
.db 6,6
.db %000000
.db %000000
.db %000000
.db %000000
.db %000000
.db %000000
WallSprite:
.db 6,6
.db %00000000
.db %11111000
.db %11111000
.db %11111000
.db %11111000
.db %11111000
Number:
.db 6,6
.db %00000000
.db %00100000
.db %01110000
.db %11011000
.db %01110000
.db %00100000
; DATA
STR0:
  .db "             ",0
STR1:
  .db "             ",0
STR2:
  .db "MOVE!",0
STR3:
  .db "...JR",0
STR4:
  .db "F1 - START GAME",0
sys_test_equalb:
  CP D
  JR NZ,equalb_no
  LD L,1
  JR equalb_end
equalb_no:
  LD L,0
equalb_end:
  RET
Perm_number:
  .dw 
sys_test_greatb:
  CP D
  JR C,sys_greatb_no
  LD L,0
  JR sys_greatb_end
sys_greatb_no
  LD L,1
sys_greatb_end
  RET
sys_mulemw:
  LD C,L
  LD B,H
  LD HL,0000
  LD A,15
sys_MLP:
  SLA E
  RL D
  JR NC, sys_MLP1
  ADD HL,BC
sys_MLP1:
  ADD HL,HL
  DEC A
  JR NZ, sys_MLP
  OR D
  RET P
  ADD HL,BC
  RET
sys_PUTSPRITE:
      Ld de,VIDEO_MEM
      Ld a,63
      Sub c
      Ld c,a
      Push hl 
      Push hl
      ROM_CALL(FIND_PIXEL)
      Add hl,de
      Ex de,hl
      Pop hl
      Ld b,(hl)
      Inc hl
      Ld c,(hl)
      Inc hl
      Push hl
      Pop ix
      Ex de,hl
sys_PS_NewRow:
      Push bc
      Ld d,(ix)
      Inc ix
      Push af
      Push hl
sys_PS_NewCol:
      Rl d
      Ld e,a
      Jr nc,sys_PS_NoPixel
      Or (hl)
      Ld (hl),a
      Jr sys_PS_NextPixel
sys_PS_NoPixel:
      Cpl
      And (hl)
      Ld (hl),a
sys_PS_NextPixel:
      Ld a,e
      Rrca
      Jr nc,sys_PS_SameByte
      Inc hl
sys_PS_SameByte:
      Djnz sys_PS_NewCol
      Pop hl
      Pop af
      Ld de,16
      Add hl,de
      Pop bc
      Dec c
      Jr nz,sys_PS_NewRow
      Pop hl
      Ret
sys_test_greatw:
  LD A,H
  CP D
  JR C,sys_greatw_no
  JR NZ,sys_greatw_yes
  LD A,L
  CP E
  JR C,sys_greatw_no
sys_greatw_yes
  LD L,0
  JR sys_greatw_end
sys_greatw_no
  LD L,1
sys_greatw_end
  RET
sys_test_lessb:
  CP D
  JR C,sys_lessb_no
  LD L,1
  JR sys_lessb_end
sys_lessb_no:
  LD L,0
sys_lessb_end:
  RET
STR5:
  .db "I GOT YOU",0
STR6:
  .db "I GOT YOU",0
  .end
